'__________________________________________________________________________________________
'\                                                                                         \
' \                                    SamChat v1.2                                         \
'  \_________________________________________________________________________________________\
'
' ---- Installation ----
' - Copy this file to "<Your Samurize Dir>\Scripts\".
' - Edit the settings found in the CONFIGURATION area below.
'
' ---- How to set up the message window ----
' - Insert a "Active Script" into Samurize and choose "SamChat.vbs".
' - Select "showLog".
' - Click "Edit Script" and edit the settings (you are allready here).
'    > Your user ID
'    > Your password
'    > URL to the SamChat server
'    > The number of lines you want to show (maximum is 20)
'    > Output format
'    > Output order
'
' ---- How to set up the chat box ----
' - Insert a "Text" field and go to the "Input" tab.
' - Check "Allow Input Controls".
' - Select "Meter Linkage" in the "Select Action Type" drop-down.
' - Add "wscript.exe .\Scripts\SamChat.vbs addLine" in the "Link Meter To"
'   textbox.
' - Change the text to whatever you want it to say in the "Display" tab.
'
' ---- Easy Set Up ----
' - I have created a simple and rough config that you can use if you have no idea how to
'   set this up on your own.
' - Just place SamChat.ini in "<Your Samurize Dir>\Configs\" and edit it
'   in your Samurize editor or use it by choosing the SamChat.ini in Samurize.
' - If you did not install Samurize to the default dir you also have to open SamChat.ini
'   in the Samurize editor, then click on "LogBox" in the "Meter List".
' - Click on the "Input" tab.
' - Edit the path in the "Link Meter To" textbox so that it matches your own Samurize dir.
' - Save your work and update Samurize.
'
' NOTICE!!!
' You have to set up your own webserver for this to work. See samchat.asp for more info.
'
'   /Krazz (krazz@semperfi.se)
'_____________________________________________________________________________________________
'
' CHANGELOG!
'
' 1.2 - 2005-04-20
'  - Fixed a bug that would halt SamChat saying User_ID had changed.
'  - Changed the weblink from www.samurize.com so it now takes you straight to the SamChat
'    page at www.samurize.com
'  - Changed the installation instructions a bit.
'  - Added the possibility to click on the chatlog and have it open in notepad. I did this so
'    it would be easier to copy text (i.e. URLs).
'
' 1.1 - 2005-04-08
'  - Fixed some replace code.
'  - Fixed the URL shown in the .ini file. It now points to www.samurize.com and is clickable.
'  - Fixed the Add Comment link in the .ini file so it works no matter where you have Samurize
'    installed on your hard drive.
'  - Fixed some spelling errors.
'  - Changed the background color in SamChat.ini.
'
'
' 1.0 - 2005-04-04
'  - Initial release. Only released to close friends for testing.
'
'---------------------------------------- CONFIGURATION --------------------------------------
Dim User_ID, User_Password, URL, Lines_to_Show, Output_Format, Output_Order


' This is the user ID you have been given by the webserver admin running the SamChat server.
User_ID = 

' This is your password, also provided by the SamChat server admin.
User_Password = ""


' The URL to the SamChat server.
URL = "http://www.yourdomain.com"


' Define how many lines of chat text you want to be shown. Maximum is 20 lines.
Lines_to_Show = 10


' Define how you want the format of the chat text.
' Available selections are:
' <user> - This will show the username of the one adding the chat entry.
' <date_long> - Date of chat entry in format YYYY-MM-DD.
' <date_short> -  Date of chat entry in format YY-MM-DD.
' <time_hour> - Time of chat entry in format HH.
' <time_minutes> - Time of chat entry in format MM.
' <time_seconds> - Time of chat entry in format SS.
' <message> - This is the chat message.
' <ip> - This will show the IP address of the user adding the entry.
Output_Format = "<date_short> <time_hour>:<time_minutes> (<user>) - <message>"


' Set the output order. Set to "TOP" if you want last entries shown at the top, otherwise
' set it to "BOTTOM".
' NOTE: If you use BOTTOM, make sure you have room for 20+ lines of text. Otherwise you
' might not be able to read the last entry.
Output_Order = "TOP"

'------------------------------------ END OF CONFIGURATION -----------------------------------









































'------------------------------------ SOURCE CODE START ------------------------------------
Dim action

On Error Resume Next

action = Wscript.arguments.Item(0)

If action = "addLine" Then
	Call addLine()
End If

Function showLog()
	Dim htmlResult
	Dim result
	Dim numChatLines
	Dim chatLine
	Dim chatLineStart
	Dim numLoops
	Dim theOrder
	Dim fso
	Dim fil
	
	numLoops = Lines_to_Show
	theOrder = Output_Order
	
	If theOrder = "TOP" Then
		theOrder = "DESC"
	ElseIf theOrder = "BOTTOM" Then
		theOrder = "ASC"
	Else
		showLog = "ERROR! The value for Output_Order is invalid."
		Exit Function
	End If
	
	htmlResult = ReturnHTML(URL & "/samchat.asp?action=showLog&user=" & User_ID & "&order=" & theOrder & "&password=" & User_Password)
	
	numChatLines = InStr(htmlResult, "-EOF-") + 5
	numChatLines = Mid(htmlResult, numChatLines, InStr(htmlResult, "</body>")-numChatLines)
	numChatLines = CInt(numChatLines)
	
	If numLoops > 20 Then
		numLoops = 20
	End If
	
	If numLoops > numChatLines Then
		numLoops = numChatLines
	End If
	
	If numChatLines > 0 Then
		chatLineStart = InStr(htmlResult, "Chatlog:<BR>") + 12
		For ctr = 1 To numLoops
			chatLine = Mid(htmlResult, chatLineStart, InStr(chatLineStart, htmlResult, "<BR>")-chatLineStart)
			chatLineStart = chatLineStart + Len(chatLine) + 4
			
			result = result & fixFormat(chatLine)
		Next
	Else
		result = "Empty"
	End If


	result = Replace(result, ";amp;", "&")
	result = Replace(result, ";brvbar;", "|")
	
	Set fso = CreateObject("Scripting.FileSystemObject")
	Set fil = fso.CreateTextFile(".\Scripts\SamChat.txt", True)
		fil.Write(result)
	fil.Close
End Function

Private Function addLine()
	Dim htmlResult
	Dim responseCode
	Dim theMessage
	
	theMessage = Inputbox(vbCrLf & vbCrLf & "Enter your message:" & vbCrLf & vbCrLf & "(A maximum of 150 characters is allowed)")
	If Len(theMessage) > 150 Then
		Call MsgBox("Your message exceeded 150 characters and was not saved.")
		Exit Function
	End If
	theMessage = Replace(theMessage, "&", ";amp;")
	theMessage = Replace(theMessage, "|", ";brvbar;")
	
	htmlResult = ReturnHTML(URL & "/samchat.asp?action=addLine&message=" & theMessage & "&user=" & User_ID & "&password=" & User_Password)
	
	responseCode = InStr(htmlResult, "Response:") + 9
	responseCode = Mid(htmlResult, responseCode, InStr(htmlResult, "<BR>")-responseCode)
	
	If responseCode = "Error" Then
		addLine = "An error occurred when you tried to add your entry!" & vbCrLf & vbCrLf & "Make sure you have configured your settings correctly."
	ElseIf responseCode = "Added" Then
		addLine = "Your entry was saved on the server."
	End If
End Function

Private Function fixFormat(chatLine)
' Available selections are:
' <user> - This will show the username of the one adding the chat entry.
' <date_long> - Date of chat entry in format YYYY-MM-DD.
' <date_short> -  Date of chat entry in format YY-MM-DD.
' <time_hour> - Time of chat entry in format HH.
' <time_minutes> - Time of chat entry in format MM.
' <time_seconds> - Time of chat entry in format SS.
' <message> - This is the chat message.
' <ip> - This will show the IP address of the user adding the entry.
	Dim aryLine
	Dim theDay
	Dim theMonth
	
	fixFormat = Output_Format
	
	aryLine = Split(chatLine, "||")
	
	fixFormat = Replace(fixFormat, "<user>", aryLine(1))
	If Day(aryLine(0)) < 10 Then
		theDay = "0" & Day(aryLine(0))
	Else
		theDay = Day(aryLine(0))
	End If
	If Month(aryLine(0)) < 10 Then
		theMonth = "0" & Month(aryLine(0))
	Else
		theMonth = Month(aryLine(0))
	End If
	
	fixFormat = Replace(fixFormat, "<date_long>", Year(aryLine(0)) & "-" & theMonth & "-" & theDay )
	fixFormat = Replace(fixFormat, "<date_short>", Right(Year(aryLine(0)), 2) & "-" & theMonth & "-" & theDay )
	If Hour(aryLine(0)) < 10 Then
		fixFormat = Replace(fixFormat, "<time_hour>", "0" & Hour(aryLine(0)))
	Else
		fixFormat = Replace(fixFormat, "<time_hour>", Hour(aryLine(0)))
	End If
	If Minute(aryLine(0)) < 10 Then
		fixFormat = Replace(fixFormat, "<time_minutes>", "0" & Minute(aryLine(0)))
	Else
		fixFormat = Replace(fixFormat, "<time_minutes>", Minute(aryLine(0)))
	End If
	If Second(aryLine(0)) < 10 Then
		fixFormat = Replace(fixFormat, "<time_seconds>", "0" & Second(aryLine(0)))
	Else
		fixFormat = Replace(fixFormat, "<time_seconds>", Second(aryLine(0)))
	End If
	fixFormat = Replace(fixFormat, "<message>", aryLine(2))
	fixFormat = Replace(fixFormat, "<ip>", aryLine(3)) & vbCrLf
End Function

Private Function ReturnHTML(sURL)
    Dim objXMLHTTP, HTML
    Set objXMLHTTP = CreateObject("Microsoft.XMLHTTP")
    objXMLHTTP.Open "POST", sURL, False
    objXMLHTTP.Send
    HTML = objXMLHTTP.responseBody
    Set objRS = CreateObject("ADODB.Recordset")
    objRS.Fields.Append "txt", 200, 45000, &H80
    objRS.Open
    objRS.AddNew
    objRS.Fields("txt").AppendChunk HTML
    ReturnHTML = objRS("txt").Value
    objRS.Close
    Set objRS = Nothing
    Set objXMLHTTP = Nothing
End Function